<?php

namespace Drupal\eca_content\Plugin\Action;

use Drupal\eca\Plugin\Action\ActionBase;

/**
 * Load current entity into token environment.
 *
 * @Action(
 *   id = "eca_token_load_entity",
 *   label = @Translation("Token: load current entity"),
 *   type = "entity"
 * )
 */
class TokenLoadEntity extends ActionBase {

  /**
   * {@inheritdoc}
   */
  public function execute($entity = NULL): void {
    if ($entity === NULL) {
      return;
    }
    $this->tokenServices->addTokenData($entity->getEntityTypeId(), $entity);
  }

}
