<?php

namespace Drupal\eca_content\Plugin\ECA\Condition;

use Drupal\Core\Entity\EntityInterface;
use Drupal\eca\Annotation\EcaCondition;
use Drupal\eca\PluginConditionBase;

/**
 * Plugin implementation of the ECA condition for new entity.
 *
 * @EcaCondition(
 *   id = "entity_is_new",
 *   label = "Entity is new"
 * )
 */
class EntityIsNew extends PluginConditionBase {

  /**
   * {@inheritdoc}
   */
  public function assertConditions(): bool {
    if (isset($this->arguments['entity'])) {
      $entity = $this->arguments['entity'];
      if ($entity instanceof EntityInterface) {
        return $entity->isNew();
      }
    }
    return FALSE;
  }

}
