<?php

namespace Drupal\eca_content\Plugin\ECA\Condition;

use Drupal\Core\Entity\FieldableEntityInterface;
use Drupal\eca\Annotation\EcaCondition;

/**
 * Plugin implementation of the ECA condition for an entity original field value.
 *
 * @EcaCondition(
 *   id = "entity_original_field_value",
 *   label = "Entity original field value"
 * )
 */
class EntityOriginalFieldValue extends EntityFieldValue {

  /**
   * {@inheritdoc}
   */
  protected function getFirstValue(): string {
    if (isset($this->arguments['entity'])) {
      $entity = $this->arguments['entity'];
      if ($entity instanceof FieldableEntityInterface && isset($entity->original) && $entity->hasField($this->configuration['field_name'])) {
        return $entity->original->get($this->configuration['field_name'])->getValue();
      }
    }
    return '';
  }

}
