<?php

namespace Drupal\eca_user\Plugin\ECA\Condition;

use Drupal\eca\Annotation\EcaCondition;

/**
 * Plugin implementation of the ECA condition of the current user's id.
 *
 * @EcaCondition(
 *   id = "current_user_id",
 *   label = "ID of current user"
 * )
 */
class CurrentUserId extends BaseUser {

  /**
   * {@inheritdoc}
   */
  public function assertConditions(): bool {
    return  (int) $this->configuration['id'] === $this->currentUser->id();
  }

  /**
   * {@inheritdoc}
   */
  public function fields(): array {
    $fields = parent::fields();
    $fields[] = [
      'name' => 'id',
      'label' => 'ID',
      'type' => 'String',
    ];
    return $fields;
  }

}
