<?php

namespace Drupal\eca\Entity\Objects;

use Drupal\eca\EcaActionInterface;
use Drupal\eca\Entity\Eca;
use Drupal\Core\Action\ActionInterface;

class EcaAction extends EcaObject {

  /**
   * @var \Drupal\Core\Action\ActionInterface
   */
  protected ActionInterface $plugin;

  /**
   * Event constructor.
   *
   * @param \Drupal\eca\Entity\Eca $eca
   * @param string $id
   * @param \Drupal\Core\Action\ActionInterface $plugin
   */
  public function __construct(Eca $eca, string $id, EcaEvent $event, ActionInterface $plugin) {
    parent::__construct($eca, $id, $event);
    $this->plugin = $plugin;
  }

  /**
   * {@inheritdoc}
   */
  public function execute(EcaObject $predecessor, $event): bool {
    if ($this->plugin instanceof EcaActionInterface) {
      $this->plugin->setEvent($event);
    }
    call_user_func_array([$this->plugin, 'execute'], $predecessor->getVariables());
    return TRUE;
  }

}
