<?php

namespace Drupal\eca\Event;

use Drupal\Core\Form\FormStateInterface;
use Symfony\Contracts\EventDispatcher\Event;

/**
 * Class FormBase
 *
 * @package Drupal\eca\Event
 */
abstract class FormBase extends Event {

  /**
   * @var array
   */
  protected array $form;

  /**
   * @var \Drupal\Core\Form\FormStateInterface
   */
  protected FormStateInterface $formState;

  /**
   * @param array $form
   * @param \Drupal\Core\Form\FormStateInterface $form_state
   */
  public function __construct(array $form, FormStateInterface $form_state) {
    $this->form = $form;
    $this->formState = $form_state;
  }

  /**
   * @return array
   */
  public function getForm(): array {
    return $this->form;
  }

  /**
   * @param array $form
   */
  public function setForm(array $form): void {
    $this->form = $form;
  }

  /**
   * @return \Drupal\Core\Form\FormStateInterface
   */
  public function getFormState(): FormStateInterface {
    return $this->formState;
  }

}
