<?php

namespace Drupal\eca\Plugin\ECA\Condition;

use Drupal\eca\Annotation\EcaCondition;
use Drupal\eca\TokenServices;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Component\HttpFoundation\RequestStack;

/**
 * Plugin implementation of the ECA condition for entity type and bundle.
 *
 * @EcaCondition(
 *   id = "route_match",
 *   label = "Route match"
 * )
 */
class RouteMatch extends BaseStringComparison {

  /**
   * {@inheritdoc}
   */
  protected function getFirstValue(): string {
    if ($request = $this->requestStack->getCurrentRequest()) {
      return $request->getBasePath();
    }
    return '';
  }

  /**
   * {@inheritdoc}
   */
  protected function getSecondValue(): string {
    return $this->configuration['value'];
  }

  /**
   * {@inheritdoc}
   */
  public function fields(): array {
    $fields = parent::fields();
    $fields[] = [
      'name' => 'value',
      'label' => 'Path',
      'type' => 'String',
    ];
    return $fields;
  }

}
