<?php

namespace Drupal\eca;

/**
 *
 */
abstract class PluginConditionBase extends PluginBase implements PluginConditionInterface {

  public const OPTION_NO = 'no';
  public const OPTION_YES = 'yes';

  /**
   * @param $name
   * @param $label
   * @param $value
   *
   * @return array
   */
  public static function checkbox($name, $label, $value): array {
    return [
      'name' => $name,
      'label' => $label,
      'type' => 'Dropdown',
      'value' => $value ? self::OPTION_YES : self::OPTION_NO,
      'extras' => [
        'choices' => [
          [
            'name' => 'no',
            'value' => self::OPTION_NO,
          ],
          [
            'name' => 'yes',
            'value' => self::OPTION_YES,
          ],
        ],
      ],
    ];
  }

  /**
   * {@inheritdoc}
   */
  final public function assertCondition(): bool {
    if (isset($this->configuration['negate']) && $this->configuration['negate'] === self::OPTION_YES) {
      return !$this->assertConditions();
    }
    return $this->assertConditions();
  }

  /**
   * {@inheritdoc}
   */
  public function fields(): array {
    return [self::checkbox('negate', 'Negate this condition', FALSE)];
  }

}
