<?php

namespace Drupal\eca;

/**
 * Interface for ECA event plugins.
 */
interface PluginEventInterface extends PluginInterface {

  /**
   * @return string
   */
  public function drupalEventClass(): string;

  /**
   * @param \Symfony\Contracts\EventDispatcher\Event|\Symfony\Component\EventDispatcher\Event $event
   * @param array $arguments
   *
   * @return bool
   */
  public function applies($event, array $arguments): bool;

  /**
   * @param \Symfony\Contracts\EventDispatcher\Event|\Symfony\Component\EventDispatcher\Event $event
   *
   * @return array
   */
  public function output($event): array;

}
