<?php

namespace Drupal\eca;

use Drupal\Component\Plugin\PluginInspectionInterface;

/**
 * Interface for ECA plugins.
 */
interface PluginInterface extends PluginInspectionInterface {

  /**
   * @param string $key
   * @param mixed $value
   *
   * @return \Drupal\eca\PluginInterface
   */
  public function setArgument(string $key, $value): PluginInterface;

  /**
   * @param array $values
   *
   * @return \Drupal\eca\PluginConditionBase
   */
  public function setArguments(array $values): PluginInterface;

  /**
   * @return string
   */
  public function drupalId(): string;

  /**
   * @return array
   */
  public function fields(): array;

}
