<?php

namespace Drupal\eca;

use Drupal\Component\Plugin\PluginInspectionInterface;
use Drupal\eca\Entity\Eca;

/**
 * Interface for ECA modeler plugins.
 */
interface PluginModelerInterface extends PluginInspectionInterface {

  /**
   * @param string $model
   *
   * @return \Drupal\eca\PluginModelerInterface
   */
  public function load(string $model): PluginModelerInterface;

  /**
   * @return bool
   */
  public function isEditable(): bool;

  /**
   * @param string $id
   * @param string $bpmn
   *
   * @return array
   */
  public function edit(string $id, string $bpmn): array;

  /**
   * @return string
   */
  public function getId(): string;

  /**
   * @return string
   */
  public function getLabel(): string;

  /**
   * @return bool
   */
  public function getStatus(): bool;

  /**
   * @return string
   */
  public function getVersion(): string;

  /**
   * @param \Drupal\eca\Entity\Eca $eca
   *
   * @return \Drupal\Component\Plugin\PluginInspectionInterface
   */
  public function readComponents(Eca $eca): PluginInspectionInterface;

  /**
   * @return \Drupal\eca\PluginModelerInterface
   */
  public function export(): PluginModelerInterface;

}
