<?php

namespace Drupal\eca;

use Drupal\Core\Cache\MemoryCache\MemoryCacheInterface;
use Drupal\Core\Utility\Token;

class TokenServices {

  /**
   * @var array
   */
  protected array $data = [];

  /**
   * @var \Drupal\Core\Utility\Token
   */
  protected Token $token;

  /**
   * @var \Drupal\Core\Cache\MemoryCache\MemoryCacheInterface
   */
  protected MemoryCacheInterface $memory_cache;

  /**
   * @param \Drupal\Core\Utility\Token $token
   * @param \Drupal\Core\Cache\MemoryCache\MemoryCacheInterface $memoryCache
   */
  public function __construct(Token $token, MemoryCacheInterface $memoryCache) {
    $this->token = $token;
    $this->memory_cache = $memoryCache;
  }

  /**
   * @param string $key
   * @param $data
   *
   * @return $this
   */
  public function addTokenData(string $key, $data): TokenServices {
    $this->data[$key] = $data;
    return $this;
  }

  /**
   * @param string $value
   *
   * @return string
   */
  public function replace(string $value): string {
    // TODO: Prepare arguments.
    return $this->token->replace($value, $this->data);
  }

}
